package ftswing;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import ftcomputing.JavaFish;
import ftcomputing.FishThread;
//import com.klg.jclass.swing.gauge.beans.*;

/**
 * berschrift:   ftSwing : Testrahmen package ftcomputing
 * Beschreibung:  erfordert javaFish.DLL / umFish20.DLL
 * Copyright:     Copyright (c) 2003
 * Organisation:  U. Mller, D-33100 Paderborn, Lange Wenne 18
 * @author Ulrich Mller
 * @version 1.0
 */

public class Form extends JFrame {
  JPanel contentPane;
  JLabel lblTitel = new JLabel();
  JButton cmdAction = new JButton();
  JButton cmdEnde = new JButton();
  JLabel lblStatus = new JLabel();
  JLabel lblAnalog = new JLabel();
  JTextField txtPortname = new JTextField();

  JavaFish ft = new JavaFish();
  Ampel ampel;

  /**Den Frame konstruieren*/
  public Form() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Initialisierung der Komponenten*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Form.class.getResource("[Ihr Symbol]")));
    contentPane = (JPanel) this.getContentPane();
    lblTitel.setFont(new java.awt.Font("Dialog", 1, 24));
    lblTitel.setHorizontalAlignment(SwingConstants.CENTER);
    lblTitel.setHorizontalTextPosition(SwingConstants.CENTER);
    lblTitel.setText("package ftcomputing");
    lblTitel.setBounds(new Rectangle(64, 40, 285, 28));
    contentPane.setLayout(null);
    this.setResizable(false);
    this.setSize(new Dimension(400, 300));
    this.setTitle("ftSwing : Testrahmen package ftcomputing");
    cmdAction.setText("START");
    cmdAction.setBounds(new Rectangle(269, 228, 107, 30));
    cmdAction.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cmdAction_actionPerformed(e);
      }
    });
    cmdEnde.setBounds(new Rectangle(268, 190, 107, 30));
    cmdEnde.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cmdEnde_actionPerformed(e);
      }
    });
    cmdEnde.setText("ENDE");
    lblStatus.setHorizontalAlignment(SwingConstants.CENTER);
    lblStatus.setHorizontalTextPosition(SwingConstants.CENTER);
    lblStatus.setText("STARTen");
    lblStatus.setBounds(new Rectangle(270, 160, 104, 22));
    lblAnalog.setFont(new java.awt.Font("Dialog", 1, 16));
    lblAnalog.setHorizontalAlignment(SwingConstants.CENTER);
    lblAnalog.setHorizontalTextPosition(SwingConstants.CENTER);
    lblAnalog.setText("-");
    lblAnalog.setBounds(new Rectangle(172, 90, 70, 27));
    txtPortname.setToolTipText("Anschlu fr das fischertechnik Interface");
    txtPortname.setText("COM2");
    txtPortname.setBounds(new Rectangle(201, 232, 53, 20));
    contentPane.add(lblTitel, null);
    contentPane.add(cmdAction, null);
    contentPane.add(cmdEnde, null);
    contentPane.add(lblStatus, null);
    contentPane.add(lblAnalog, null);
    contentPane.add(txtPortname, null);
  }
  /**berschrieben, so dass eine Beendigung beim Schlieen des Fensters mglich ist.*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  public class Ampel extends FishThread {
    public Ampel(JavaFish ft){
      super(ft);
    }
    public void run(){
      int Runde = 0;
       do {
        Runde++;
        lblStatus.setText("Runde : " + Runde);
        lblAnalog.setText("EX : " + ft.getAnalog(0));
        ft.setMotor(1, ft.ON);
        ft.pause(1000);
        ft.setMotor(1, ft.OFF);
        ft.setMotor(2, ft.ON);
        ft.pause(500);
        ft.setMotor(2,ft.OFF);
        ft.setMotor(3, ft.ON);
        ft.pause(1234);
        ft.setMotor(2, ft.ON);
        ft.pause(500);
        ft.setMotor(3, ft.OFF);
        ft.setMotor(2, ft.OFF);
      } while (!ft.finish(1));
      ft.clearMotors();
      ft.closeInterface();
      lblStatus.setText("Finito");
      cmdEnde.setText("ENDE");
      cmdAction.setEnabled(true);
    }
  }

  void cmdEnde_actionPerformed(ActionEvent e) {
    if(cmdEnde.getText() == "ENDE") System.exit(0);
    else {
      ft.emergencyHalt = true;
      try{ampel.join();} catch(InterruptedException ex){}
    }
  }

  void cmdAction_actionPerformed(ActionEvent e) {
    String Portname;
    int res;

    ft.setAnalogScan(true);
    Portname = txtPortname.getText().toUpperCase();
    txtPortname.setText(Portname);
    if(ft.openInterface(Portname) == ft.FT_ERROR) {
      lblStatus.setText("Is Nich");
      return;
    };

    ampel = new Ampel(ft);
    ampel.start();
    cmdAction.setEnabled(false);
    cmdEnde.setText("HALT");
    cmdEnde.requestFocus();
  }
}
